import { SearchResponse } from './apifetch';
interface ApiResponse {
    status: number;
    text: string;
}
export interface IndexingDocument {
    id?: string;
    url?: string;
    title?: string;
    main_content?: string;
    custom_fields?: Record<string, string | number>;
}
/**
 * Fetch document
 */
declare const getDocument: (apiHostname: string, sitekey: string, privatekey: string, id: string) => Promise<SearchResponse>;
/**
 * Add document
 */
declare const saveDocument: (apiHostname: string, sitekey: string, privatekey: string, document: IndexingDocument) => Promise<ApiResponse>;
/**
 * Batch add documents
 */
declare const saveDocumentsBatch: (apiHostname: string, sitekey: string, privatekey: string, documents: {
    documents: IndexingDocument[];
}) => Promise<ApiResponse>;
/**
 * Delete document
 */
declare const deleteDocument: (apiHostname: string, sitekey: string, privatekey: string, id: string) => Promise<ApiResponse>;
/**
 * Batch delete documents
 */
declare const deleteDocumentsBatch: (apiHostname: string, sitekey: string, privatekey: string, batch: {
    documents: string[];
}) => Promise<ApiResponse>;
export { getDocument, saveDocument, saveDocumentsBatch, deleteDocument, deleteDocumentsBatch };
//# sourceMappingURL=indexingapi.d.ts.map